#include "per_ext.h"

/* 3/89 Matt Wilson */
float ExpSum(argc,argv)
int argc;
char **argv;
{
float 		maxval;
float 		rate;
float 		minval;
float 		x,y;
ElementList	*list;
Element		*element;
char 		*path;
int		i;
float		px,py;
float		sum;

    if(argc < 6){
	printf("usage: %s path rate maxval minval x y\n",argv[0]);
	return(0);
    }
    path = argv[1];
    rate = Atof(argv[2]);
    maxval = Atof(argv[3]);
    minval = Atof(argv[4]);
    px = Atof(argv[5]);
    py = Atof(argv[6]);

    list = WildcardGetElement(path,1);
    sum = 0;
    for(i=0;i<list->nelements;i++){
	element = list->element[i];
	x = element->x;
	y = element->y;
	/*
	** set the weight according to the radial distance between
	** the source and dst and the velocity
	*/
	sum += (maxval - minval)*exp(rate*sqrt(
		pow(x - px,2.0) + pow(y - px,2.0))) + minval;
    }
    FreeElementList(list);
    return(sum);
}
