#include "shell_ext.h"

void do_load_lib(argc,argv)
int argc;
char **argv;
{
char	*name;
char 	libname[80];
PFI 	func;

    if(argc < 2){
	printf("usage: %s library_name\n",argv[0]);
	return;
    }
    /* 
    ** get the base name for the library of symbol table components 
    */
    name = argv[1];
    /* 
    ** load in the data structure components of the symbol table 
    */
    sprintf(libname,"LIBRARY_%s",name);
    /* 
    ** look up the address of the function 
    */
    if((func=(PFI)GetFuncAddress(libname))== NULL){
	/*
	** try and find the component libraries
	*/
	sprintf(libname,"DATA_%s",name);
	if((func=(PFI)GetFuncAddress(libname))== NULL){
	    Warning();
	    printf("can't find data structure library '%s'\n",name);
	} else {
	    func();
	}
	sprintf(libname,"FUNC_%s",name);
	if((func=(PFI)GetFuncAddress(libname))== NULL){
	    Warning();
	    printf("can't find function library '%s'\n",name);
	} else {
	    func();
	}
    } else {
	/*
	** and call the function to fill the symbol table entries
	*/
	func();
    }
}

LibraryHeader(lib,date)
char *lib;
char *date;
{
char libstr[100];
    sprintf(libstr,"%s %s",lib,"library");
    printf("Loading.. %-20s : updated %-8s\n",libstr,date);
}
