#include <stdio.h>
#include "parse.h"

/*
** parse.c
**
**	Routines involved in parse tree construction.
*/

extern int errno;

ParseNode *PTNew(type, data, left, right)

int		type;
ResultValue	data;
ParseNode	*left;
ParseNode	*right;

{	/* PTNew --- Make a new parse tree node and initialze fields */

	ParseNode	*pn;

	pn = (ParseNode *) malloc(sizeof(ParseNode));
	if (pn == NULL)
	  {
	    perror("PTNew");
	    sig_msg_restore_context(0, errno);
	    /* No Return */
	  }

	pn->pn_val.r_type = type;
	pn->pn_val.r = data;
	pn->pn_left = left;
	pn->pn_right = right;

	return(pn);

}	/* PTNew */


PTFree(pn)

ParseNode	*pn;

{	/* PTFree --- Free an entire parse tree given root */

	if (pn != NULL)
	  {
	    PTFree(pn->pn_left);
	    PTFree(pn->pn_right);
	    free(pn);
	  }

}	/* PTFree */
